<template>
  <div class="relative">
    <div class="relative">
      <input
        type="text"
        v-model="localSearch"
        class="w-64 input input-bordered input-md max-w-xs border-gray-200"
        placeholder="Type here"
        @input="onInputSearch"
        @enter="loadPlaces({ action: 'search', pageToken: '' })"
        @focusout="onFocusOut"
      />

      <button
        class="btn btn-xs btn-circle absolute top-1/4 right-1"
        @click="onClearInput"
      >x</button>
    </div>

    <div v-if="lists.length" class="absolute w-full top-10 left-1 mt-2 z-10 bg-white">
      <ul class="w-80 h-auto max-h-40 overflow-x-hidden overflow-y-auto bg-white">
        <a
          v-for="item in lists"
          :key="item.place_id"
          href="javascript:;"
          class="cursor-pointer rounded-sm"
          @click="onSelected(item.description)"
        >
          <li class="w-full border rounded-sm px-2 hover:bg-sky-500 z-10 hover:text-white">
            {{ item.description }}
          </li>
        </a>
      </ul>
    </div>
  </div>
</template>

<script setup lang="ts">
import { ref, watch } from 'vue'
const { propSearch, loadPlaces, setPropSearch } = defineProps(['propSearch', 'loadPlaces', 'setPropSearch'])
const localSearch = ref(propSearch)
const lists = ref<Array<Results>>([])

type Results = {
  description: String;
  place_id: String;
  reference: String;
}

type Response = {
  statusCode: Number;
  results: Array<Results>;
}

watch(localSearch, (newInputSearch) => {
  setPropSearch(localSearch.value)
})

const onDebounce = useDebounce(cb => cb(), 500)
const onInputSearch = () => {
  onDebounce(() => {
    $fetch('/api/restaurants/place/autocomplete', {
      method: 'POST',
      body: {
        keyword: localSearch.value,
      }
    })
    .then((response: Response) => {
      if (response.statusCode === 200) {
        lists.value = response.results
      }
    })
  })
}

const onSelected = async (placeDescription: String) => {
  lists.value = []
  localSearch.value = placeDescription
  loadPlaces({ action: 'search', pageToken: '' })
}

const onClearInput = () => {
  setPropSearch('')
  localSearch.value = ''
  lists.value = []
}

const onFocusOut = () => {
  clearTimeout(onFocusOut)

  setTimeout(() => { lists.value = [] }, 800)
}
</script>
